<?php
/**
* @copyright   (C) 2011 iJoomla, Inc. - All rights reserved.
* @license  GNU General Public License, version 2 (http://www.gnu.org/licenses/gpl-2.0.html) 
* @author  iJoomla.com webmaster@ijoomla.com
* @url   http://www.ijoomla.com/licensing/
* the PHP code portions are distributed under the GPL license. If not otherwise stated, all images, manuals, cascading style sheets, and included JavaScript  
* are NOT GPL, and are released under the IJOOMLA Proprietary Use License v1.0 
* More info at http://www.ijoomla.com/licensing/
*/
// No direct access to this file
defined('_JEXEC') or die('Restricted access');
jimport('joomla.application.component.modellist');

class MediapassModelCategories extends JModel{
	
	public function __construct($config = array()){
		if(empty($config['filter_fields'])){
			$config['filter_fields'] = array(
				'title', 'a.title',				
				'lft', 'a.lft'				
			);
		}
		parent::__construct($config);
	}
	
	function getItems(){
		global $mainframe;
		$db =& JFactory::getDBO();
		$sections = array(0=>0);
		
		$section_filter = JRequest::getVar("section", "");
		$where = " 1=1 ";
		if($section_filter != "" && $section_filter != "0"){
			$where .= " and c.section = ".intval($section_filter);
		}
		else{
			$sql = "select id from #__sections where published=1";
			$db->setQuery($sql);
			$db->query();
			$sections_result = $db->loadAssocList();
			if(isset($sections_result) && count($sections_result) > 0){
				foreach($sections_result as $key=>$value){
					$sections[] = $value["id"];
				}
			}
			$where .= " and c.section in (".implode(",", $sections).")";
		}
		$sql = "select id, title, alias from #__categories c where ".$where;		
		$db->setQuery($sql);
		$db->query();
		$result = $db->loadAssocList();
		
		$return = array();
		$total = count($result);
		$return["total"] = $total;
		
		$option = JRequest::getVar("option", "");
		$config = new JConfig();
		$limit = $mainframe->getUserStateFromRequest("$option.viewlistlimit", 'limit', intval($config->list_limit));
		$limitstart = intval($mainframe->getUserStateFromRequest("$option.view{$option}limitstart", 'limitstart', 0));
		
		require_once(JPATH_SITE.DS.'administrator'.DS.'includes'.DS.'pageNavigation.php');
		$pageNav = new JPagination($total, $limitstart, $limit);
		
		$sql = "select id, title, alias from #__categories c where ".$where." limit ".$pageNav->limitstart.", ".$pageNav->limit;
		$db->setQuery($sql);
		$db->query();
		$result = $db->loadAssocList();
		
		$return = array('items' => $result,
						'total' => $total,
						'limit' => $limit, 
						'limitstart' => $limitstart);
		return $return;
	}
	
	function getMediapassCategories(){
		$db =& JFactory::getDBO();
		$sql = "select id, category_id from #__mediapass_categories";
		$db->setQuery($sql);
		$db->query();
		$result = $db->loadAssocList("category_id");
		return $result;
	}
	
	function store(){
		$db =& JFactory::getDBO();
		$sql = "select category_id from #__mediapass_categories";
		$db->setQuery($sql);
		$db->query();
		$from_database = $db->loadAssocList();
		if(isset($from_database)){
			$temp = array();
			foreach($from_database as $key=>$value){
				$temp[] = $value["category_id"];
			}
			$from_database = $temp;
		}
		else{
			$from_database = array();
		}
		
		$checked = JRequest::getVar("cid", array(), "post", "array");
		$all_ids_per_page = JRequest::getVar("all_ids", "");
		$all_ids_per_page = explode(",", $all_ids_per_page);
		$for_delete = array_diff($all_ids_per_page, $checked);
		$for_save = array_diff($checked, $from_database);
		
		if(count($for_delete) == 0){
			$for_delete[] = 0;
		}
		
		$sql = "delete from #__mediapass_categories where category_id in (".implode(",", $for_delete).")";
		$db->setQuery($sql);		
		if($db->query()){
			if(isset($for_save) && count($for_save) > 0){
				foreach($for_save as $key=>$value){
					$sql = "insert into #__mediapass_categories(`category_id`) values (".$value.")";					
					$db->setQuery($sql);
					if(!$db->query()){
						return false;
					}
				}
			}
		}
		else{
			return false;
		}
		return true;
	}
	
	function getSections(){		
		$db =& JFactory::getDBO();
		$sql = "select id, title from #__sections where published=1";
		$db->setQuery($sql);
		$db->query();
		$result = $db->loadAssocList();
		return $result;
	}
}

?>

