<?php   
/**
* @copyright   (C) 2011 iJoomla, Inc. - All rights reserved.
* @license  GNU General Public License, version 2 (http://www.gnu.org/licenses/gpl-2.0.html) 
* @author  iJoomla.com webmaster@ijoomla.com
* @url   http://www.ijoomla.com/licensing/
* the PHP code portions are distributed under the GPL license. If not otherwise stated, all images, manuals, cascading style sheets, and included JavaScript  
* are NOT GPL, and are released under the IJOOMLA Proprietary Use License v1.0 
* More info at http://www.ijoomla.com/licensing/
*/
// no direct access
defined('_JEXEC') or die;
include_once( JPATH_SITE."/libraries/joomla/database/table/category.php");
error_reporting(1);
jimport('joomla.environment.response');
jimport('joomla.plugin.plugin');
jimport('joomla.event.plugin');

require_once ( JPATH_BASE .DS.'includes'.DS.'framework.php' );

class plgContentMediapass_plugin extends JPlugin{

	function getSettings(){
		$database =& JFactory::getDBO();
		$sql = "select * from #__mediapass_settings";
		$database->setQuery($sql);
		$database->query();
		$result = $database->loadAssocList();
		return $result;
	}
	
	function getCategories(){
		$database =& JFactory::getDBO();
		$sql = "select * from #__mediapass_categories";
		$database->setQuery($sql);
		$database->query();
		$result = $database->loadAssocList();
		if(isset($result) && count($result) > 0){
			$temp = array();
			foreach($result as $key=>$value){
				$temp[] = $value["category_id"];
			}
			$result = $temp;
		}
		else{
			$result = array();
		}
		return $result;
	}
	
	function getScript($settings, $option){
		$script = "";
		if($option == 0){
			$option = $settings["0"]["media_type"];
		}
		if($option == 1){ // Page Overlay
			$script = '<noscript><meta http-equiv=\'REFRESH\' content=\'0; url=http://www.mediapass.com/subscription/noscriptredirect?key='.$settings["0"]["account_id"].'&uri='.JURI::root().'\'></noscript>
<script type="text/javascript" src="http://www.mediapass.com/static/js/mm.js"></script>
<script type="text/javascript">MediaPass.init('.$settings["0"]["account_id"].');</script>'; 
		}
		elseif($option == 2){ // In-Page
			$script = '<noscript><meta http-equiv=\'REFRESH\' content=\'0; url=http://www.mediapass.com/subscription/noscriptredirect?key='.$settings["0"]["account_id"].'&uri='.JURI::root().'\'></noscript>
<script type="text/javascript" src="http://www.mediapass.com/static/js/mm.js"></script>
<script type="text/javascript">MediaPass.init('.$settings["0"]["account_id"].');</script>';
		}
		elseif($option == 3){ // Video Overlay
			$width = trim($settings["0"]["width"]) == "0" ? "400" : trim($settings["0"]["width"]);
			$height = $settings["0"]["height"] == "0" ? (4/10)*$width : $settings["0"]["height"];
			$delay = $settings["0"]["delay"] == "0" ? "15" : $settings["0"]["delay"];
			
			$document =& JFactory::getDocument();
			$meta_title = $document->getTitle();
			
			$title = $settings["0"]["title"] == "" ? $meta_title : $settings["0"]["title"];
			$title = str_replace('"', "&quot;", $title);
			
			$script = '<noscript><meta http-equiv=\'REFRESH\' content=\'0; url=http://www.mediapass.com/subscription/noscriptredirect?key='.$settings["0"]["account_id"].'&uri='.JURI::root().'\'></noscript>
<script type="text/javascript" src="http://www.mediapass.com/static/js/mm.js"></script>
<script type="text/javascript">MediaPass.init('.$settings["0"]["account_id"].', { width:'.$width.', height:'.$height.', delay:'.$delay.', title:"'.$title.'", vid:"12345"});</script>';
		}
		return $script;
	}
	
	function getDiv($settings, $option){
		$div = "";
		if($option == 0){
			$option = $settings["0"]["media_type"];
		}
		if($option == 1){ // Page Overlay
			$div = '<div id="media-pass-tease" style="display:none;">My Text Here</div>';
		}
		elseif($option == 2){ // In-Page
			$div = '<div class="media-pass-article">My Premium Content</div>';
		}
		elseif($option == 3){ // Video Overlay
			//nothing to return, all is in javascript included;
		}
		return $div;
	}
	
	function onPrepareContent(&$article, &$params, $page=0){
		$doc =& JFactory::getDocument();
		$settings = $this->getSettings();	
		$app = JFactory::getApplication();
		$option = JRequest::getVar("option", "");
		$view = JRequest::getVar("view", "");
		if($app->isAdmin()){
			return;
		}
		
		if($option != "com_content"){
			return;
		}
		
		if($option == "com_content" && $view != "article"){
			return;
		}
		
		$db =& JFactory::getDBO();
		$categories = $this->getCategories();
		
		$article_id = intval(JRequest::getVar("id", "0"));
		$category_id = intval(JRequest::getVar("catid", "0"));
		if($category_id == "0" && intval($article_id) != "0"){
			$sql = "select catid from #__content where id=".intval($article_id);
			$db->setQuery($sql);
			$db->query();
			$category_id = $db->loadResult();
		}
		
		$find = false;
		//search by tags from articles-------------------------------------------
		preg_match("/{mediapass}(.*){\/mediapass}/msU", $article->text, $matches);
		if(isset($matches) && count($matches) > 0){
			$script = $this->getScript($settings, 0);
			$div = $this->getDiv($settings, 0);
			$doc->addCustomTag($script);
			$article->text = str_replace($matches["0"], $div, $article->text);
			$find = true;
		}
		
		preg_match("/{mediapass-overlay}(.*){\/mediapass-overlay}/msU", $article->text, $matches);
		if(isset($matches) && count($matches) > 0){
			$script = $this->getScript($settings, 1);
			$div = $this->getDiv($settings, 1);
			$doc->addCustomTag($script);
			$article->text = str_replace($matches["0"], $div, $article->text);
			$find = true;
		}
		
		preg_match("/{mediapass-inpage}(.*){\/mediapass-inpage}/msU", $article->text, $matches);
		
		if(isset($matches) && count($matches) > 0){
			$script = $this->getScript($settings, 2);
			$div = $this->getDiv($settings, 2);
			$doc->addCustomTag($script);
			$article->text = str_replace($matches["0"], $div, $article->text);
			$find = true;
		}
		
		preg_match("/{mediapass-video}(.*){\/mediapass-video}/msU", $article->text, $matches);
		if(isset($matches) && count($matches) > 0){
			$script = $this->getScript($settings, 3);
			$doc->addCustomTag($script);
			$article->text = str_replace('{mediapass-video}', '<div id="media-pass-video">', $article->text);
			$article->text = str_replace('{/mediapass-video}', '</div">', $article->text);
			$find = true;
		}
		//search by tags from articles-------------------------------------------
		
		$script = $this->getScript($settings, 0);
		$div = $this->getDiv($settings, 0);
		
		//search for assigned categories
		if(in_array($category_id, $categories) && $find !== TRUE){
			//Entire article
			if($settings["0"]["position"] == "0"){
				$doc->addCustomTag($script);
				$article->text = '<div id="div_article_content" style="display:none;">'.$article->text.'</div>'.$div;
			}
			//Everything that comes after the "read more" tag
			elseif($settings["0"]["position"] == "1"){
				$fulltext = $article->fulltext;
				if(trim($fulltext) != ""){
					$doc->addCustomTag($script);
					$article->text = $article->introtext.'<div id="div_article_content" style="display:none;">'.$fulltext.'</div>'.$div;
				}
			}
		}
		
		$script_for_check = '
			<script type="text/javascript" src="http://www.mediapass.com/static/js/mm.js"></script>
			<script type="text/javascript">
				function mediapassCheckLogin(){
					var result= {};
					$mp.getJSON("http://mediapass.com/subscription/CheckLoggedInSubscriber/?uri=" + escape(location.href)  + "&key='.$settings["0"]["account_id"].'&callback=?", result, function (result){
					if(result.isSubscriber){
						if(document.getElementById("div_article_content")){
							document.getElementById("div_article_content").style.display = "block";
						}
						if(document.getElementById("media-pass-article")){
							element = document.getElementById("media-pass-article");
							element.parentNode.removeChild(element);
						}
						if(document.getElementById("media-pass-tease")){
							element = document.getElementById("media-pass-tease");
							element.parentNode.removeChild(element);
						}
					}
					else{
						if(document.getElementById("div_article_content")){
							element = document.getElementById("div_article_content");
							element.parentNode.removeChild(element);
						}
						MediaPass.init('.$settings["0"]["account_id"].');
					}
				});
				}
				
				function mediapassLogOut(){
					var result= {};
					$mp.getJSON("http://www.mediapass.com/subscription/LogOutSubscriber/?callback=?", result, function (result) {
						window.top.location.replace(location.href);
					});
				}
				
				mediapassCheckLogin();
			</script>';
		//$doc->addCustomTag($script_for_check);
		echo $script_for_check;
		return true;
	}
}

?>